/* -*- javascript -*-
Copyright 2006-2012 Dr. Detlef Groth, Schwielowsee, Germany.
License: http://creativecommons.org/licenses/LGPL/2.1/
System : JSCOMPONENTS_INIT_JS :
Created By : Dr. Detlef Groth, Schwielowsee, Germany
Last Modified : <121113.1033>
ID : $Id: jsComponents.js,v 1.45 2006/05/11 10:57:43 dgroth Exp $
Source : $Source: /cygdrive/d/cvs/jsComponents/css-js/jsComponents.js,v $
$Log: jsComponents.js,v $
Description	
Notes
*/
/* http://www.delphifaq.com/faq/f1031.shtml */
String.prototype.trim=function (){
return this.replace(/^\s*/, "").replace(/\s*$/, "");
}
function addLoadEvent(func){
var oldonload=window.onload;
if(typeof window.onload != 'function'){
window.onload=func;
}else{
window.onload=function(){
if(oldonload){
oldonload();
}
func();
}
}
}
/* Event Utilities */
function evtGetTarget(evt){
var elem;
if(evt.target){
elem=(evt.target.nodeType == 3) ? evt.target.parentNode : evt.target;
}else{
elem=evt.srcElement;
}
return elem;
}
/*
more efficient to construct the functions ones
Thanks to Dean Edwards http://dean.edwards.name/
*/
var evtAdd;
if(document.addEventListener){
evtAdd=function(element, type, handler){
element.addEventListener(type, handler, null);
};
} else if (document.attachEvent){
evtAdd=function(element, type, handler){
element.attachEvent("on" + type, handler);
};
}else{
alert("Your browser is not supported!");
}
/* XMLHttpRequestLoader - Class */
function XMLHttpRequestLoader (){
var xmlhttp=false;
if(typeof(XMLHttpRequest) != "undefined"){
xmlhttp=new XMLHttpRequest();
}else{
try {
xmlhttp=new ActiveXObject("Msxml2.XMLHTTP");
} catch (ev0){
try {
xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
} catch (ev1){
xmlhttp=false;
}
}
}
this.loadXML=loadXML;
this.loadText=loadText;
this.loadIEText=loadIEText;
function loadText(url,cb,targetNode){
if(typeof(XMLHttpRequest) != "undefined"){
loadMozText(url,cb,targetNode);
} else if (xmlhttp){
loadIEText(url,cb,targetNode);
}else{
alert("Browser not supported or JavaScript or ActiveX (IE) is not enabled!");
}
}
function loadXML(url,cb,targetNode){
if(typeof(XMLHttpRequest) != "undefined"){
load(url,cb,targetNode);
} else if (xmlhttp){
loadIE(url,cb,targetNode);
}else{
alert("Browser not supported or JavaScript or ActiveX (IE) is not enabled!");
}
}
function load(srcUrl,cb,targetNode){
var req=new XMLHttpRequest();
req.overrideMimeType('text/xml');
req.open("GET", srcUrl, true);
req.onreadystatechange=function(){
if(req.readyState == 4){
if(cb && targetNode){
cb(req.responseXML, targetNode);
} else if (cb){
cb(req.responseXML);
}
}
};
req.setRequestHeader('Content-Type', 'text/xml');
req.setRequestHeader('Cache-Control', 'no-cache');
req.send(null);
}
function loadMozText(srcUrl,cb,targetNode){
var req=new XMLHttpRequest();
req.open("GET", srcUrl, true);
req.onreadystatechange=function(){
if(req.readyState == 4){
var xmlText=req.responseText;
if(xmlText.match("<body>")){
xmlText=xmlText.replace(/<\/html>/,"");
xmlText=xmlText.slice(xmlText.indexOf("<body>"));
xmlText=xmlText.replace(/<\/?body>/g,"");
}
if(cb && targetNode){
cb(xmlText, targetNode);
} else if (cb){
cb(xmlText);
}
}
};
req.setRequestHeader('Cache-Control', 'no-cache');
req.send(null);
}
function loadIE(srcUrl,cb,targetNode){
xmlhttp.open("GET", srcUrl);
xmlhttp.onreadystatechange=function(){
if(xmlhttp.readyState == 4){
if(cb){
var xmlObj=xmlhttp.responseXML;
if(!xmlObj.hasChildNodes){
xmlObj=new ActiveXObject("Msxml2.DOMDocument");
var xmlText=xmlhttp.responseText;
if(xmlText.match("<body>")){
xmlText=xmlText.replace(/<\/html>/,"");
xmlText=xmlText.slice(xmlText.indexOf("<body>"));
}
xmlObj.loadXML(xmlText);
if(cb && targetNode){
cb(xmlObj, targetNode);
}else{
cb(xmlObj);
}
}else{
if(cb && targetNode){
cb(xmlhttp.responseXML, targetNode);
}else{
cb(xmlhttp.responseXML);
}
}
}
}
};
xmlhttp.setRequestHeader('Content-Type', 'text/xml');
xmlhttp.setRequestHeader('Cache-Control', 'no-cache');
xmlhttp.send(null);
}
function loadIEText(srcUrl,cb,targetNode){
xmlhttp.open("GET", srcUrl);
xmlhttp.onreadystatechange=function(){
if(xmlhttp.readyState == 4){
if(cb){
var xmlText=xmlhttp.responseText;
xmlText=xmlText.replace(/<\/html>/,"");
if(xmlText.match("<body>")){
xmlText=xmlText.replace(/<\/html>/,"");
xmlText=xmlText.slice(xmlText.indexOf("<body>"));
xmlText=xmlText.replace(/<\/?body>/g,"");
}
if(cb && targetNode){
cb(xmlText, targetNode);
}else{
cb(xmlText);
}
}
}
};
xmlhttp.setRequestHeader('Cache-Control', 'no-cache');
xmlhttp.send(null);
}
}
function microAjax(B,A){
this.bindFunction=function(E,D){return function(){return E.apply(D,[D])}};
this.stateChange=function(D){if(this.request.readyState==4){this.callbackFunction(this.request.responseText)}};
this.getRequest=function(){if(window.ActiveXObject){return new ActiveXObject("Microsoft.XMLHTTP")}else{if(window.XMLHttpRequest){return new XMLHttpRequest()}}return false};this.postBody=(arguments[2]||"");this.callbackFunction=A;this.url=B;this.request=this.getRequest();if(this.request){var C=this.request;C.onreadystatechange=this.bindFunction(this.stateChange,this);if(this.postBody!==""){C.open("POST",B,true);C.setRequestHeader("X-Requested-With","XMLHttpRequest");C.setRequestHeader("Content-type","application/x-www-form-urlencoded");C.setRequestHeader("Connection","close")}else{C.open("GET",B,true)}C.send(this.postBody)}
};
function jsComponent (node){
try {
eval("mfunc="+node.className+";");
mfunc(node);
} catch (ev){}
}
window.onload=function(){
var divs=document.getElementsByTagName("DIV");
/* divs.length is ineffective but robust against adding new divs at runtime */
for (var i=0;i < divs.length;i++){
if(divs.item(i).className && divs.item(i).className.match(/JS.+/)){
var comp=new jsComponent(divs.item(i));
}
}
}
var maxZ=100;
function JSDragArea (element){
this.grabDown=grabDown;
this.grabClick=grabClick;
evtAdd(element,"mousedown",this.grabDown);
evtAdd(element,"mouseclick",this.grabClick);
/* var dw=new DebugWindow();*/
function grabClick(e){
e=e||window.event;
var node=evtGetTarget(e);
if(node.style.zIndex != maxZ){
maxZ++;
node.style.zIndex=maxZ;
}
}
function grabDown(e){
e=e||window.event;
var node=evtGetTarget(e);
if(node.style.zIndex != maxZ){
maxZ++;
node.style.zIndex=maxZ;
}
var clientX0=e.clientX;
var clientY0=e.clientY;
var top=node.style.top;
var left=node.style.left;
window.document.onmousemove=function (e){
var deltaX; var deltaY;
e=e||window.event;
deltaX=e.clientX - clientX0;
deltaY=e.clientY - clientY0;
node.style.left=parseInt(left)+parseInt(deltaX) + "px";
node.style.top=parseInt(top)+parseInt(deltaY) + "px";
};
window.document.ondragstart=function(){return false};
window.document.onmouseup=function(e){
this.onmousemove=null;
this.onmouseup=null;
this.ondragstart=null;
};
}
}



function JSDynContent(div){
var dsrc=div.getAttribute("datasrc");
this.loadSource=loadSource;
var src=null ;
evtAdd(div, "click", this.loadSource); 
function initializeResult(response,el){
el.innerHTML=response;
var divs=el.getElementsByTagName("DIV") ;
el.style.cursor='auto';
for (var i=0;i < divs.length;i++){
if(divs.item(i).className && divs.item(i).className.match(/JS.+/)){
var comp=new jsComponent(divs.item(i));
}
}
src.style.cursor='pointer';
}
function loadSource(e){
e=e||window.event;
var element=evtGetTarget(e);
var dsrc=element.getAttribute("datasrc");
var items=dsrc.split(",");
var target=document.getElementById(items[1]);
element.style.cursor='wait' ;
target.style.cursor='wait';
var loader=new XMLHttpRequestLoader;
src=element ;
loader.loadText(items[0],initializeResult,target)
}
}
function JSDynListAbbr (element){
var parent=element.parentNode;
var abbrs=parent.getElementsByTagName("abbr");
var targetList=document.createElement("dl");

var l=abbrs.length; 
var resList=new Array();
for (var x=0;x < l;x++){
rx=/(.+)\((.+)\)/;
res=rx.exec(abbrs.item(x).innerHTML.replace(/[\n\r]/g," "));
if(res){
resList.push(""+RegExp.$2+":::"+RegExp.$1);
}
}
resList.sort();
l=resList.length;
for (var x=0;x < l;x++){
var arr=resList[x].split(":::");
var dt=document.createElement("dt");
dt.appendChild(document.createTextNode(arr[0]));
var dd=document.createElement("dd");
dd.appendChild(document.createTextNode(arr[1]));
targetList.appendChild(dt);
targetList.appendChild(dd);
}
element.appendChild(targetList) ;
}
function JSDynListDfn (element){
var parent=element.parentNode;
var dfns=parent.getElementsByTagName("dfn");
var targetList=document.createElement("dl");

var l=dfns.length; 

var resList=new Array();
for (var x=0;x < l;x++){
rx=/(.+) - (.+)/mg;
text=dfns.item(x).innerHTML.replace(/[\r\n]/g, " ");
res=rx.exec(text);
if(res){
resList.push(""+RegExp.$1+":::"+RegExp.$2);
}
}
resList.sort();
l=resList.length;
for (var x=0;x < l;x++){
var arr=resList[x].split(":::");
var dt=document.createElement("dt");
dt.appendChild(document.createTextNode(arr[0]));
var dd=document.createElement("dd");
dd.appendChild(document.createTextNode(arr[1]));
targetList.appendChild(dt);
targetList.appendChild(dd);
}
element.appendChild(targetList) ;
}
function JSDynListLink (element){
var parent=element.parentNode;
var ls=parent.getElementsByTagName("a");
var targetList=document.createElement("ol");
var l=ls.length;
var y=0 ;
for (var x=0;x < l;x++){
if(ls.item(x).getAttribute("href") && ls.item(x).getAttribute("href").match(/^http:/)){
var as=targetList.getElementsByTagName("a") ;
var found=0 ;
for (var z=0;z < as.length;z++){
if(as.item(z).getAttribute("href") == ls.item(x).getAttribute("href")){
ls.item(x).innerHTML=z+1 ;
found=1 ;
break;
}
}
if(found == 0){
var li=document.createElement("li");
var a=document.createElement("a");
y=y +1 ;
a.setAttribute("href", ls.item(x).getAttribute("href"));
a.appendChild(document.createTextNode(ls.item(x).getAttribute("href")));
li.appendChild(document.createTextNode(ls.item(x).innerHTML+ " "));
li.appendChild(a);
targetList.appendChild(li);
ls.item(x).innerHTML=""+y ;
}
}
}
element.appendChild(targetList);
}
function JSDynListRef (element){
var parent= element.parentNode;
var ol=element.getElementsByTagName("ol")[0];

var lliste=ol.getElementsByTagName("li");
if(lliste && lliste.length > 0){
var cites=parent.getElementsByTagName("cite");
for (var x=0;x < cites.length; x++){
var cites_text="" ;
var refs=cites.item(x).innerHTML.split(",");
for (var y=0;y < refs.length; y++){
for (var z=0;z < lliste.length; z++){
if(lliste.item(z).getAttribute("id") && 
lliste.item(z).getAttribute("id") == refs[y]){

if(cites_text != ""){
cites_text=cites_text+","
}
cites_text=cites_text+""+(z+1);
}	
}

}
cites.item(x).innerHTML=cites_text;
}
}
}
JSDynListToc.counter=0;
function JSDynListToc (element){
JSDynListToc.counter++;
var lastArray=new Array(4);
var next=element.nextSibling;
var targetList=document.createElement("ul");
var x=1 ;
var lastidx=0;
while (next){
	if (next.tagName && next.tagName.match(/h([1-4])/i)){
var idx=RegExp.$1 ;
var pidx=idx-1;
var name="test";
var as=next.getElementsByTagName("a");
var alink =document.createElement("a");
if(as.length > 0 && as.item(0).getAttribute("name")){
name=as.item(0).getAttribute("name");
}else{
var a=document.createElement("a");
name="dynlistoc"+JSDynListToc.counter+"x"+x++ ;
a.setAttribute("name",name);
a.setAttribute("id",name);
next.appendChild(a);


}
alink.setAttribute("href", "#"+name);
var li=document.createElement("li"); 
li.appendChild(alink);
alink.appendChild(document.createTextNode(next.innerHTML.replace(/<.+?>/g,"")));
if(idx > 1 && lastArray[pidx]){
if(idx > lastidx){
var ul=document.createElement("ul");
ul.appendChild(li);
lastArray[pidx].appendChild(ul);
lastArray[idx]=ul ;
} else if (idx == lastidx){
lastArray[idx].appendChild(li);
}else{
lastArray[pidx].appendChild(li);
}
}else{
targetList.appendChild(li);
lastArray[idx]=targetList ;

}
lastidx=idx;

}
next=next.nextSibling;
}
element.appendChild(targetList);
}
/*var el=document.getElementById("toc");*/
/*el.innerHTML="" ;*/
/*JSDynListToc(el);*/
function JSFormInputNoQuotationMark (el){
var input=el.getElementsByTagName("input").item(0);
input.onkeyup=function(evt){
evt=evt || window.event;
input=evtGetTarget(evt)
input.value=input.value.replace(/"/,"''");
};
}
function JSFormInputInteger (el){
var input=el.getElementsByTagName("input").item(0);
input.onkeypress=function(evt){
evt=evt || window.event;
var charCode=evt.which || evt.keyCode;
var charStr=String.fromCharCode(charCode);
if(charCode> 57 || charCode == 40 || charCode == 41 || charCode == 44 || charCode == 46 || charCode == 32){
return false;
}
/* && /[A0-9]/.test(charStr) */
};
}
function JSFormInputFloat (el){
var input=el.getElementsByTagName("input").item(0);
input.onkeypress=function(evt){
evt=evt || window.event;
var charCode=evt.which || evt.keyCode;
var charStr=String.fromCharCode(charCode);
if(charCode> 57 || charCode == 44 || charCode == 32){
return false;
}
/* && /[A0-9]/.test(charStr) */
};
}
function JSFormInputIntegers (el){
var input=el.getElementsByTagName("input").item(0);
input.onkeypress=function(evt){
evt=evt || window.event;
var charCode=evt.which || evt.keyCode;
var charStr=String.fromCharCode(charCode);
if(charCode> 57 || charCode == 46){
return false;
}
/* && /[A0-9]/.test(charStr) */
};
}
function JSFormInputFloats (el){
var input=el.getElementsByTagName("input").item(0);
input.onkeypress=function(evt){
evt=evt || window.event;
var charCode=evt.which || evt.keyCode;
var charStr=String.fromCharCode(charCode);
if(charCode> 57){
return false;
}
/* && /[A0-9]/.test(charStr) */
};
}
function JSFormInputName (el){
var input=el.getElementsByTagName("input").item(0);
input.onkeypress=function(evt){
evt=evt || window.event;
var charCode=evt.which || evt.keyCode;
var charStr=String.fromCharCode(charCode);
if(charCode == 40 || charCode == 41 || (charCode > 46 && charCode< 58)){
return false;
}
/* && /[A0-9]/.test(charStr) */
};
}
function JSFormInputEmail (el){
var inp=el.getElementsByTagName("input").item(0);
this.onChange=onChange;
evtAdd(inp,"change",this.onChange);
function onChange (evt){
target=evtGetTarget(evt);
val=target.value;
val=val.trim()
target.value=val
if(!val.match(/^[-A-Za-z0-9\.]+@[-a-z0-9\.]+?\.[a-z]+$/)){
alert("Only valid email adresses allowed! You entered: '"+target.value+"'");
target.focus();
} 
}
}
function JSSearchList (element){
this.keyup=keyup;
var div=window.document.createElement("div");
var text=window.document.createTextNode("Search: ");
div.className="input";
div.appendChild(text);
var input=window.document.createElement("input");
input.setAttribute("name", "inputvalue");
input.setAttribute("type", "text");
evtAdd(input, "keyup", this.keyup);
div.appendChild(input);
element.insertBefore(div, element.firstChild);
element.style.listStylePosition="outside";
function keyup(e){
var input=evtGetTarget(e);
var element=input.parentNode.parentNode;
var links=element.getElementsByTagName("A");
var m=input.value;
if(e.keyCode == 13){
for (var i=0;i < links.length; i++){
if(links[i].parentNode.style.display == ""){
if((links[i].getAttribute("target") == "" ||
links[i].getAttribute("target") == null) &&
(window.document.getElementsByTagName("BASE").item(0) == null ||
window.document.getElementsByTagName("BASE").item(0).getAttribute("target") == null ||
window.document.getElementsByTagName("BASE").item(0).getAttribute("target") == ""))
{
window.location.href=links[i].getAttribute("href");
}else{
if(links[i].getAttribute("target") != null && links[i].getAttribute("target") != ""){
eval("parent.frames."+links[i].getAttribute("target")+".location.href='"+links[i].getAttribute("href")+"';");
}else{
eval("parent.frames."+window.document.getElementsByTagName("BASE").item(0).getAttribute("target")+".location.href='"+links[i].getAttribute("href")+"';");
}
}
break;
}
}
}else{
var found=0;
if(m == ""){
for (var i=0;i < links.length; i++){
links[i].parentNode.style.display ="";
if(found == 0){
links[i].parentNode.style.backgroundColor="#dddddd";
}else{
links[i].parentNode.style.backgroundColor="white";
}
found ++;
}
}else{
for (var i=0;i < links.length; i++){
if(links[i].firstChild.data.match(eval("/^"+m+"/i"))){
links[i].parentNode.style.display ="";
if(found == 0){
links[i].parentNode.style.backgroundColor="#dddddd";
}else{
links[i].parentNode.style.backgroundColor="white";
}
found ++;
}else{
links[i].parentNode.style.display ="none";
links[i].parentNode.style.backgroundColor="white";
}
}
}
}
}
}
function JSQAjaxTable(element){
var id=element.getAttribute("targetid");
var url=element.getAttribute("datasrc");
var cnt=$.ajax({
url: url,
async: false
}).responseText;
var target=document.getElementById(id);
var table=document.createElement("table");
table.className="tablesorter";
var tbody=document.createElement("tbody");
var thead=document.createElement("thead");
var x=0 ;
var lines=cnt.split(/\n/);
for (var x=0;x < lines.length; x++){ 
if(!lines[x].match(/[a-zA-Z0-9]/)){ continue;}
var tr=document.createElement("tr");
var cols=lines[x].split(/\t/);
for (var y=0;y < cols.length;y++){
if(x == 0){
var th=document.createElement("th");
th.appendChild(document.createTextNode(cols[y]));
tr.appendChild(th);
}else{
var td=document.createElement("td");
td.appendChild(document.createTextNode(cols[y]));
tr.appendChild(td);
}
if(x == 0){
thead.appendChild(tr);
}else{
tbody.appendChild(tr);
}
}
}
table.appendChild(thead);
table.appendChild(tbody);
target.appendChild(table);
return ;
}
function JSQTableSort (element){
var table=element.getElementsByTagName("table")[0];
$(table).addClass('tablesorter');
alert("Hi");
$(table).tablesorter({widgets:['zebra']});
}
function JSSelectCombinedMover (el){
selDivs=el.getElementsByTagName('div')
if(el.getElementsByClassName){
selDivs=el.getElementsByClassName("JSSelectsCombined2");
}else{
return
}
len=selDivs.length;
this.moveUp=moveUp;
this.moveDown=moveDown;
for (i=0; i<len ;i++){
if(selDivs.item(i).className != "JSSelectsCombined2"){
continue
}
var divUp =document.createElement("span");
divUp.appendChild(document.createTextNode("\u00A0"));
selDivs.item(i).appendChild(divUp);
if(i > 0){
divUp.className='moveUp';
evtAdd(divUp,"click",this.moveUp);
}else{
divUp.className='moveNot';
}
var divDown=document.createElement("span");
divDown.appendChild(document.createTextNode("\u00A0"));
selDivs.item(i).appendChild(divDown);
if(i < len-1){
divDown.className='moveDown';
evtAdd(divDown,"click",this.moveDown);
}else{
divDown.className='moveNot'
}
}
function sortSelect(selElem){
var tmpAry=new Array();
for (var i=0;i<selElem.options.length;i++){
tmpAry[i]=new Array();
tmpAry[i][0]=selElem.options[i].text;
tmpAry[i][1]=selElem.options[i].value;
}
tmpAry.sort();
while (selElem.options.length > 0){
selElem.options[0]=null;
}
for (var i=0;i<tmpAry.length;i++){
var op=new Option(tmpAry[i][0], tmpAry[i][1]);
selElem.options[i]=op;
}
return;
}
function getSelectedValues (selectElement){
res=[];
for (var i=0; i < selectElement.options.length; i++){
if(selectElement.options[i].selected ==true){
res.push(selectElement.options[i].value);
}
}
return(res)
}
function doMove (selects,nextSelects){
var values=new Array("", "", "", "", "", "")
for (i=0; i < selects.length;i++){
if(selects.item(i).className.match(/multi/)){
values[i]=getSelectedValues(selects.item(i))
}else{
values[i]=selects.item(i).value;
}
}
for (i=0; i < nextSelects.length;i++){
if(nextSelects.item(i).className.match(/multi/)){
values[i+nextSelects.length]=getSelectedValues(nextSelects.item(i))
}else{
values[i+nextSelects.length]=nextSelects.item(i).value;
}
}
for (i=0; i < selects.length; i++){
selects.item(i).value=""
nextSelects.item(i).value=""
if(i > 0){
optss=selects.item(i).getElementsByTagName("option");
optns=nextSelects.item(i).getElementsByTagName("option");
optnsLen=optns.length
for (var j=optss.length-1; j > 0; j--){
opt=selects.item(i).removeChild(optss.item(j));
nextSelects.item(i).appendChild(opt);
}
for (var j=optnsLen-1; j > 0;j--){
opt=nextSelects.item(i).removeChild(optns.item(j));
selects.item(i).appendChild(opt);
}
sortSelect(selects.item(i));
sortSelect(nextSelects.item(i));
}
}
for (i=0; i < selects.length; i++){
var valitem=values[i+selects.length]
if(typeof(valitem) == "string"){
selects.item(i).value=valitem
}else{
for (j=0; j < selects.item(i).options.length;j++){
for (k=0; k < valitem.length; k ++){
if(selects.item(i).options.item(j).value == valitem[k]){
selects.item(i).options.item(j).selected=true
}
}
}
}
valitem=values[i]
if(typeof(valitem) == "string"){
nextSelects.item(i).value=valitem
}else{
for (j=0; j < nextSelects.item(i).options.length;j++){
for (k=0; k < valitem.length; k ++){
if(nextSelects.item(i).options.item(j).value == valitem[k]){
nextSelects.item(i).options.item(j).selected=true
}
}
}
}
if(selects.item(i).className.match(/multi/)){
if(selects.item(i).options.length == 2){
selects.item(i).setAttribute("size","2")
} else if (selects.item(i).options.length < 4){
selects.item(i).setAttribute("size","4")
}else{
selects.item(i).setAttribute("size","4")
}
}
if(nextSelects.item(i).className.match(/multi/)){
if(nextSelects.item(i).options.length == 2){
nextSelects.item(i).setAttribute("size","2")
} else if (nextSelects.item(i).options.length < 4){
nextSelects.item(i).setAttribute("size","4")
}else{
nextSelects.item(i).setAttribute("size","4")
}
}
}
}
function moveDown (e){
span=evtGetTarget(e);
selects=span.parentNode.getElementsByTagName("select");
nextSelects=span.parentNode.nextSibling.nextSibling.getElementsByTagName("select");
doMove(selects,nextSelects)
}
function moveUp (e){
span=evtGetTarget(e);
selects=span.parentNode.getElementsByTagName("select");
var values=new Array("", "", "", "", "", "")
for (i=0; i < selects.length;i++){
values[i]=selects.item(i).value
}
nextSelects=span.parentNode.previousSibling.previousSibling.getElementsByTagName("select");
doMove(selects,nextSelects)
}
}
function debug (txt){
return;
deb=document.getElementById("debug");
if(deb){
deb.innerHTML=deb.innerHTML+"\n"+txt;
}else{
deb=document.createElement("pre");
document.body.appendChild(deb);
deb.createAtrribute("debug");
deb.setAtrribute("id","debug");
deb.innerHTML=txt;
}
}
function JSSelectSingle (sel,datasrc){
var valA=sel.value
sel.selectedIndex=0;
opt1=sel.getElementsByTagName("option");
opt1.item(0).innerHTML=" "
for (var i=opt1.length-1; i>0;i--){
sel.removeChild(opt1.item(i));
}
var childs=datasrc.childNodes;
for (var i=0; i<childs.length;i++){
if(childs.item(i).tagName=="LI"){
var nd=childs.item(i).firstChild
var nv =nd.nodeValue
nv=nv.replace(/\s*\n.+/,"")
nv=nv.replace(/^\s+/,"");
var op=document.createElement("option")
var txt= document.createTextNode(nv)
if(valA == nv){
op.setAttribute("selected","selected")
}
op.appendChild(txt)
sel.appendChild(op);
}
}
}
function JSSelectsCombined2 (el){
id=el.getAttribute("id")
id=id.replace(/[0-9]+$/,"");
var dataId= id+"data";
var datasrc=document.getElementById(dataId).getElementsByTagName("ul").item(0);
var selects=el.getElementsByTagName("select");
if(selects.length == 1){
JSSelectSingle (selects.item(0),datasrc);
return
}
this.optionChange=optionChange;
this.optionChangeSecond=optionChangeSecond;
evtAdd(selects.item(0),"change",this.optionChange);
if(selects.length == 3){
evtAdd(selects.item(1),"change",this.optionChangeSecond);
}
var valA=selects.item(0).value
valA=selects.item(0).options[selects.item(0).selectedIndex].text
var valB=selects.item(1).options[selects.item(1).selectedIndex].text
selects.item(0).selectedIndex=0;
var valC;
var classC=false;
if(selects.length == 3){
valC=selects.item(2).options[selects.item(2).selectedIndex].text
selects.item(2).getElementsByTagName("option").item(0).innerHTML=" "
classC=selects.item(2).className.search(/number/)>=0
}
opt1=selects.item(0).getElementsByTagName("option");
opt1.item(0).innerHTML=" "
selects.item(1).getElementsByTagName("option").item(0).innerHTML=" "
for (var i=opt1.length-1; i>0;i--){
selects.item(0).removeChild(opt1.item(i));
}
var dataArray=new Array()
var childs=datasrc.childNodes;
for (var i=0; i<childs.length;i++){
if(childs.item(i).tagName=="LI"){
var nd=childs.item(i).firstChild
var nv =nd.nodeValue
nv=nv.replace(/\s*\n.+/,"")
nv=nv.replace(/^\s+/,"");
nv=nv.replace(/\s*$/,"");
debug(""+nv)
dataArray[nv]=new Array()
var ul2=childs.item(i).getElementsByTagName("ul").item(0);
if(ul2){
var secChilds=ul2.childNodes;
for (var j=0; j<secChilds.length;j++){
if(secChilds.item(j).tagName=="LI"){
var nd2=secChilds.item(j).firstChild
var nv2 =nd2.nodeValue
nv2=nv2.replace(/\s*\n.+/,"")
nv2=nv2.replace(/^\s*/,"");
nv2=nv2.replace(/\s*$/,"");
debug(" "+nv2)
dataArray[nv][nv2]=new Array()
var ul3=secChilds.item(j).getElementsByTagName("ul").item(0);
if(ul3){
var childs3=ul3.childNodes;
for (var k=0; k<childs3.length;k++){
if(childs3.item(k).tagName=="LI"){
var nv3=childs3.item(k).innerHTML
nv3=nv3.replace(/\n.+/,"")
nv3=nv3.replace(/^\s*/,"");
nv3=nv3.replace(/\s*$/,"");
debug(" "+nv3)
dataArray[nv][nv2].push(nv3)
}
}
}
}
}
}
}
}
debug("initial"+dataArray.length)
var idxA=0; var a=0;
var idxB=0;var b=0;
var idxC=0;var c=0;
for (key in dataArray){
var op=document.createElement("option")
var txt= document.createTextNode(key)
if(valA == key){
op.setAttribute("selected","selected")
op.selected=true;
idxA=a
for (keyB in dataArray[key]){
if(valB == keyB){
idxB=b
if(valC != undefined){
for (keyC in dataArray[key][keyB]){
if(valC == dataArray[key][keyB][keyC]){
idxC=c
break
}
c=c+1
}
}
break
}
b=b+1
}
}
op.appendChild(txt)
selects.item(0).appendChild(op);
a=a+1
}
if(selects.item(0).selectedIndex > 0){
this.optionChange(selects.item(0))
if(idxB >= 0 && valB.search(/[A-Z0-9a-z]/)>=0){
selects.item(1).selectedIndex=idxB+1
this.optionChangeSecond(selects.item(1))
if(valC){
opts=selects.item(2).getElementsByTagName("option")
selects.item(2).selectedIndex=-1
els=valC.split(";")
for (el in els){
str="^"+els[el]+" "
rgx=new RegExp(str)
for (var i=1; i<opts.length; i++){
found=classC && rgx.test(opts.item(i).innerHTML)
if(els[el] == opts.item(i).innerHTML || (classC && rgx.test(opts.item(i).innerHTML) )){
opts.item(i).setAttribute("selected","selected")
opts.item(i).selected=true
}
}
}
}
}
}
function optionChange (evt){
var target=evtGetTarget(evt) || evt;
options=target.getElementsByTagName("option");
idx=target.selectedIndex-1;
debug("selected:"+target.value+":")
selects=target.parentNode.getElementsByTagName("select");
opt2=selects.item(1).getElementsByTagName("option");
if(selects.length == 3){
opt3=selects.item(2).getElementsByTagName("option");
for (var i=opt3.length-1; i>0;i--){
selects.item(2).removeChild(opt3.item(i));
}
}
for (var i=opt2.length-1; i>0;i--){
selects.item(1).removeChild(opt2.item(i));
}
debug("selected2:"+target.value+":")
val=target.value
if(val==""){
val=options.item(target.selectedIndex).innerHTML
val=val.replace(/\s$/,"")
target.setAttribute("value",val)
}
for (key in dataArray[val]){
debug("internal key="+key)
var op=document.createElement("option")
var txt= document.createTextNode(key)
op.appendChild(txt)
selects.item(1).appendChild(op);
}
selects.item(1).selectedIndex=0;
target.selectedIndex=idx+1
}
function optionChangeSecond (evt){
var target=evtGetTarget(evt) || evt;
options=target.getElementsByTagName("option");
idx=target.selectedIndex;
val2=target.value
if(val2 == ""){
val2=selects.item(1).getElementsByTagName("option").item(selects.item(1).selectedIndex).innerHTML
}
selects=target.parentNode.getElementsByTagName("select");
val1=selects.item(0).value
if(val1 == ""){
val1=selects.item(0).getElementsByTagName("option").item(selects.item(0).selectedIndex).innerHTML
}
opt3=selects.item(2).getElementsByTagName("option");
for (var i=opt3.length-1; i>0;i--){
selects.item(2).removeChild(opt3.item(i));
}
for (key in dataArray[val1][val2]){
var op=document.createElement("option")
var txt= document.createTextNode(dataArray[val1][val2][key])
op.appendChild(txt)
if(selects.item(2).className.match(/number/)){
op.value=op.innerHTML.replace(/ .+/,"")
}
selects.item(2).appendChild(op);
}
if(selects.item(2).className.match(/multi/)){
if(dataArray[val1][val2].length<=1){
selects.item(2).removeAttribute("multiple")
selects.item(2).setAttribute("size","1")
}else{
selects.item(2).setAttribute("multiple","multiple")
if(dataArray[val1][val2].length < 4){
selects.item(2).setAttribute("size",4)
}else{
selects.item(2).setAttribute("size",4)
}
}
}
selects.item(2).selectedIndex=0;
}
}
function JSSelectsCombined (el){
this.optionChange=optionChange;
this.optionChangeSecond=optionChangeSecond;
this.optionChangeTarget=optionChangeTarget;
this.optionDoSelect=optionDoSelect;
var selects=el.getElementsByTagName("select");
evtAdd(selects.item(0),"change",this.optionChange);
if(selects.length == 3){
evtAdd(selects.item(1),"change",this.optionChangeSecond);
}
selIndex=selects.item(0).selectedIndex
var selects2=selects.item(1).innerHTML;
var options2=new Array;
var options3=new Array;
var selValue2='';
for (var j=1; j < selects.length;j++){
sibling=selects.item(j);
options=sibling.getElementsByTagName("option");
if(j==1){
selValue2=options.item(sibling.selectedIndex).value
}
for (var i=options.length-1; i>0;i--){
if(j ==1){
options2.push(sibling.removeChild(options.item(i)));
}
if(j ==2){
options3.push(sibling.removeChild(options.item(i)));
}
}
}
this.optionChangeTarget(selects.item(0))
this.optionDoSelect(selects.item(0),selValue2)
function optionDoSelect(select,value){
select2=select.parentNode.getElementsByTagName("select").item(1)
options=select2.getElementsByTagName("option");
for (var i=0; i < options.length;i++){
if(options.item(i).value==value){
select2.selectedIndex=i
}
}
}
function optionChangeSecond (evt){
target=evtGetTarget(evt);
options=target.getElementsByTagName("option");
idxB=target.selectedIndex;
siblingBefore=target.parentNode.getElementsByTagName("select").item(0);
idxA=siblingBefore.selectedIndex;
siblingAfter=target.parentNode.getElementsByTagName("select").item(2);
options=siblingAfter.getElementsByTagName("option");
for (var i=options.length-1; i>0;i--){
siblingAfter.removeChild(options.item(i));
}
siblingAfter.selectedIndex=0;
currIdxA=1;
currIdxB=1;
for (var i=options3.length-1;i>=0;i--){
if(options3[i].innerHTML.match(/^-+$/)){
currIdxA=currIdxA+1;
currIdxB=1;
continue;
}
if(options3[i].innerHTML.match(/^\s*$/)){
currIdxB=currIdxB+1;
continue;
}
if(currIdxA == idxA && currIdxB==idxB){
siblingAfter.appendChild(options3[i]);
}
}
}
function optionChange (evt){
target=evtGetTarget(evt);
optionChangeTarget(target);
}
function optionChangeTarget (target){
options=target.getElementsByTagName("option");
idx=target.selectedIndex;
selects=target.parentNode.getElementsByTagName("select");
opt2=selects.item(1).getElementsByTagName("option");
for (var i=opt2.length-1; i>0;i--){
selects.item(1).removeChild(opt2.item(i));
}
currIdx=1;
for (var i=options2.length-1; i>= 0;i--){
if(options2[i].innerHTML.match(/^\s*$/)){
currIdx=currIdx+1;
continue;
}
if(currIdx == idx){
selects.item(1).appendChild(options2[i]);
}
if(currIdx>idx){
break
}
}
selects.item(1).selectedIndex=0;
if(selects.item(2)){
selects.item(2).selectedIndex=0;
options=selects.item(2).getElementsByTagName("option");
for (var i=options.length-1; i>0;i--){
siblingAfter.removeChild(options.item(i));
}
}
}
}
function JSTabBox (element){
var ie5=document.all && 
document.getElementById && 
navigator.userAgent.toLowerCase().indexOf('opera')==-1?1:0 ;

this.raiseTab=raiseTab ;
evtAdd(element, "click", this.raiseTab); 
var div=document.createElement("DIV") ;

div.setAttribute("nowrap","true");


element.insertBefore(div,element.firstChild) ;
var ul=document.createElement("UL");
div.appendChild(ul);
var panels=element.getElementsByTagName("DIV") ;
if(panels.item(1).getAttribute("title") == "N"){
div.className="JSTabNumbers" ;
}else{
div.className="JSTabs" ;
}
var k=0 ;
var curr=0 ;
for (var j=0;j < panels.length;j++){

if(panels.item(j).className == "JSTabPanel" && 
panels.item(j).parentNode == element && panels.item(j).getAttribute("title")){
var li=document.createElement("LI");
if(panels.item(j).getAttribute("current")){
if(panels.item(j).getAttribute("current") == "true"){
li.className="current" ;
curr=k ;
}
}
var t ;
if(div.className == "JSTabs"){
t=document.createTextNode(" "+panels.item(j).getAttribute("title")+" ");
}else{
t=document.createTextNode(" "+(k+1)+" ");
}
panels.item(j).removeAttribute("title");
li.appendChild(t);
li.style.cursor=(ie5 ? "hand" : "pointer");
ul.appendChild(li);
k++ ;
}
}
ul.getElementsByTagName("LI").item(curr).className="current" ;
ul.getElementsByTagName("LI").item(curr).pointer="" ;
if(k == 1){
div.style.display="none";
}
showPanel(element, curr);
function showPanel (parent,index){
var child=parent.firstChild ;
var curr=0;
while (child != null){
if(child.className == "JSTabPanel"){
if(index == curr){
child.style.display="block" ;
}else{
child.style.display="none" ;
}
curr++ ;
}
child=child.nextSibling ;
}
}
function getIndex (el){
var idx=0 ;
var sibling=el.previousSibling;
while (sibling != null){
if(sibling.nodeName == el.nodeName){
idx++ ;
}
sibling=sibling.previousSibling ;
}
return idx ;
}
function raiseTab (e){
e=e||window.event;
var node=evtGetTarget(e);
var parent=node.parentNode ;
if(parent.parentNode.className != "JSTabs" && parent.parentNode.className != "JSTabNumbers"){ return }
var a= parent.getElementsByTagName("LI");
for (var x=0;x < a.length;x++){
a[x].className="" ;
a[x].style.cursor=(ie5 ? "hand" : "pointer") ;
}
node.className= "current" ;
node.style.cursor="" ;
var index=getIndex(node) ;
showPanel(node.parentNode.parentNode.parentNode, index);
}
}
function JSTableFilter (div){
this.keyup=keyup;
this.ie=navigator.appName.search(/Internet Explorer/) > 0
var start=new Date().getTime();
var ths=div.getElementsByTagName("th");
var minputs=div.getElementsByTagName("input");
var tbody=div.getElementsByTagName("tbody")[0]
var trs=tbody.getElementsByTagName("tr");
var messageWidget=document.createElement("p");
div.appendChild(messageWidget);
messageWidget.className="JSMessageWidget"
for (var i=0;i< ths.length; i++){
var inputs=ths.item(i).getElementsByTagName("input");
var input= null;
var div=null;
if(inputs.length==1){
input=inputs.item(0);
}else{
div=window.document.createElement("div");
div.className="input";
input=document.createElement("input");
div.appendChild(input);
ths.item(i).appendChild(div)
if(ths.item(i).className.match("ignore")){
input.style.display="none";
}
}
if(input){
input.setAttribute("name", "inputvalue"+i);
input.setAttribute("type", "text");
evtAdd(input, "keyup", this.keyup);
evtAdd(input,"click",function (e){ e.cancelBubble=true; })
}
}
if(ie){
this.dta=new Array(trs.length);
this.rows=trs.length;
this.cols=tbody.getElementsByTagName("td").length/trs.length;
for (var i=0;i < trs.length;i++){
var tds=trs.item(i).getElementsByTagName("td");
this.dta[i]=new Array(tds.length);
for (var j=0;j<tds.length;j++){
this.dta[i][j]=tds.item(j).innerHTML;
}
}
}else{
}
function keyup(e){
var start=new Date().getTime();
var input=evtGetTarget(e);
idx=input.getAttribute("name").substr(10,1)
val=input.value;//getAttribute("value")
var patt=new RegExp("^"+val)
var founds=0
if(window.event && window.event.keyCode){
var key=window.event.keyCode
} else if (e.which){
key=e.which
}
if(key!=13){
return
}
var vals=new Array();
for (var i=0; i< minputs.length;i++){
vals[i]=minputs.item(i).value;
}
if(ie){
if(tbody.innerText){
tbody.innerText="";
}else{
tbody.innerHTML="";
}
for (var i=0;i < rows;i++){
var x=0;
for (var j=0; j < minputs.length;j++){
var inp=dta[i][j]
if(dta[i][idx] != null && vals[j] != ""){
txt=dta[i][j]
var patt=new RegExp("^"+vals[j])
if(vals[j].slice(0,1) == "!"){
var patt=new RegExp("^"+vals[j].slice(1))
if(!patt.test(txt)){
x=x+1
}else{
break
}
}else{
var patt=new RegExp("^"+vals[j])
if(patt.test(txt)){
x=x+1;
}else{
break;
}
}
}else{
x=x+1;
}
}
if(x==minputs.length){
var tr=document.createElement("tr");
for (var j =0;j < cols; j++){
var td=document.createElement("td");
td.innerHTML=dta[i][j];
tr.appendChild(td);
}
tbody.appendChild(tr);
}
}
messageWidget.innerHTML=(new Date().getTime()-start+" milliseconds for "+tbody.getElementsByTagName("tr").length+ " items");
}else{
tbody.style.display="none";
l=trs.length;
for (var i=0; i < l;i++){
var x=0;
for (var j=0; j < minputs.length;j++){
tr=trs.item(i)
var inp=tr.getElementsByTagName("td")[j];
txt=inp.innerHTML
if(vals[j] != ""){
if(vals[j].slice(0,1) == "!"){
var patt=new RegExp("^"+vals[j].slice(1))
if(!patt.test(txt)){
x=x+1;
}else{
break;
}
}else{
var patt=new RegExp("^"+vals[j]);
if(patt.test(txt)){
x=x+1;
}else{
break;
}
}
}else{
x=x+1;
}
}
if(x==minputs.length){
tr.style.display="";
founds=founds+1;
}else{
tr.style.display="none";
}
}
tds=trs.item(trs.length-1).getElementsByTagName("td");
messageWidget.innerHTML=(new Date().getTime()-start+" milliseconds with "+founds+ " items");
tbody.style.display="";
}
}
}
function JSFilterTable (div){
JSTableFilter (div)
}
function JSTableStripe(div){
var table=div.getElementsByTagName("table")[0];
var types=new Array("even","odd");
var trs=table.getElementsByTagName("tr");
for (var i=0;i < trs.length ;i++){
var mod=i % 2;
trs.item(i).className=types[mod];
}
}
function JSTableSort(div){
var table=div.getElementsByTagName("table")[0];
var types=new Array();
var headers=table.getElementsByTagName('th');
var order="asc";
var lastI=100;
tr=table.getElementsByTagName("tr").item(0);
tds=tr.getElementsByTagName("th");
var widths=new Array()
for (var i= 0;i< tds.length;i++){
widths[i]=getStyle(tds.item(i),"width")
}
for (var i=0; i < headers.length;i++){
types[i]=headers.item(i).className;
}
for (var i=0; i < headers.length;i++){
if(headers.item(i).className.match(/SortNumber/)){
headers[i].onclick=build_sorter(table,i,"n");
} else if (headers.item(i).className.match(/SortString/)){
headers[i].onclick=build_sorter(table,i,"s");
}
}
function sort_table (table,extract_fct,sort_fct){
var clones=new Array();
var tbody=table.getElementsByTagName('tbody')[0];
var rows=tbody.getElementsByTagName('tr');
var l=rows.length;
for (var i=0; i < l;i++){
var r=rows[i];
if(r.getElementsByTagName("td").length>1){
var v=extract_fct(r);
clones[i]={
value : v,
element : r
};
}
}
if(sort_fct){
clones.sort(sort_fct);
}else{
clones.sort();
}
if(order == "asc"){
clones.reverse();
}
while(tbody.firstChild){
tbody.removeChild(tbody.firstChild);
}
for (var i=0; i < l; i++){
tbody.appendChild(clones[i].element);
}
if(rows.item(0).className == "even" || rows.item(0).className == "odd"){
JSTableStripe(table.parentNode);
}
tr=table.getElementsByTagName("tr").item(0);
tds=tr.getElementsByTagName("td");
for (var i=0;i < tds.length;i++){
tds.item(i).style.width=widths[i];
}
}
function compare_numbers(a,b){
return (a.value-b.value);
}
function compare_strings(a,b){
a=a.value;b=b.value;
if(""+a<""+b) return (-1);
if(""+a>""+b) return (1);
if(""+a==""+b) return (0);
}
function extract_string_ci (r,i){
var text=r.getElementsByTagName('td')[i].innerHTML.toLowerCase();
text=text.replace(/<.+?>/g,"");
text=text.replace(//,"o").replace(//,"a").replace(//,"u").replace(//,"ss");
return String(text);
}
function extract_string_c (r,i){
var text=r.getElementsByTagName('td')[i].innerHTML;
text=text.replace(/<.+?>/g,"");
return String(text);
}
function extract_number (r,i){
var n=r.getElementsByTagName('td')[i].innerHTML;
return parseFloat(n);
}
function build_sorter(table,i,type){
return function(){
var ths=table.getElementsByTagName("th");
if(ths.length==0){
ths=table.parentNode.parentNode.getElementsByTagName("th");
}
for (var j=0;j < ths.length;j++){
ths.item(j).className=types[j];
}
if(order == 'desc' && lastI == 1){
order="asc";
ths.item(i).className=ths.item(i).className.replace(/ Sort(Asc|Desc)/,"");
ths.item(i).className=ths.item(i).className+" SortAsc";
}else{
ths.item(i).className=ths.item(i).className.replace(/ Sort(Asc|Desc)/,"");
ths.item(i).className=ths.item(i).className+" SortDesc";
order="desc";
}
lastI=1;
if(type == 'n'){
sort_table(
table,function(r){
return extract_number(r,i);
},
compare_numbers
);
} else if (type == 's'){
sort_table(
table, function (r){
return extract_string_ci(r,i);
},
compare_strings
);
}
}
}
}
function getStyle(oElm, strCssRule){
var strValue="";
if(document.defaultView && document.defaultView.getComputedStyle){
strValue=document.defaultView.getComputedStyle(oElm, "").getPropertyValue(strCssRule);
}
else if(oElm.currentStyle){
try{
strCssRule=strCssRule.replace(/\-(\w)/g, function (strMatch, p1){
return p1.toUpperCase();
});
strValue=oElm.currentStyle[strCssRule];
}
catch(e){
}
	}
	return strValue;
}
function JSTableScrollable (el){
thead=el.getElementsByTagName("thead").item(0);
thead.className="JSTheadScrollable";
tr=el.getElementsByTagName("tbody").item(0).getElementsByTagName("tr").item(0);
tableScroll=el.getElementsByTagName("table").item(0);
tableScroll.className="JSTableScrollable";
thead=thead.parentNode.removeChild(thead);
tableNew=document.createElement("table")
tableNew.appendChild(thead)
attrs=Array("width","cellpadding","cellspacing","border");
for (i in attrs){
if(attrs[i]=="width"){
tableNew.setAttribute(attrs[i],tableScroll.getAttribute(attrs[i]));
}else{
tableNew.setAttribute(attrs[i],tableScroll.getAttribute(attrs[i]));
}
}
tableNew.className="JSTableScrollable";
el.parentNode.insertBefore(tableNew,el);
tableNew.style.width=parseInt(tableScroll.getAttribute("width"))+"px"
tableScroll.style.width=parseInt(tableScroll.getAttribute("width"))+"px"
ths=tableNew.getElementsByTagName("th");
tds=tr.getElementsByTagName("td")
for (var j=0;j < 3;j++){
for (var i= 0;i< tds.length;i++){
/* alert("New:TH="+getStyle(ths.item(i),"width"))*/
width=parseInt(getStyle(tds.item(i),"width"));
if(j==1){
tds.item(i).style.width=width+"px";
}
w=width+1+"px"
ths.item(i).style.width=w;
}
}
}
function JSTableEdit (el){
var tbody=el.getElementsByTagName("tbody")[0];
this.cellClick=cellClick;
this.onBlurInput=onBlurInput;
this.lastInput=null;
var initData= { inputs : [] }
evtAdd(tbody, "click", this.cellClick);
var ins=tbody.getElementsByTagName("input");
for (var i=0;i < ins.length;i++){
evtAdd(ins.item(i),"blur",this.onBlurInput);
ins.item(i).style.display="none";
initData.inputs[ins.item(i).name]=ins.item(i).value
}
function onBlurInput (e){
var inp=evtGetTarget(e);
inp.style.display="none";
if(!inp.nextSibling){
inp.parentNode.appendChild(document.createTextNode(" "));
}
inp.parentNode.className="changed";
if(initData.inputs[inp.name] == inp.value){
inp.parentNode.className="";
}
inp.nextSibling.data =inp.value;
this.lastInput=null;
}
function cellClick (e){
var el=evtGetTarget(e);
inp=el.getElementsByTagName("input").item(0);
if(inp){
if(this.lastInput){
this.lastInput.style.display="none";
if(!this.lastInput.nextSibling){
this.lastInput.parentNode.appendChild(document.createTextNode(" "));
}
this.lastInput.parentNode.className="changed";
if(initData.inputs[this.lastInput.name] == this.lastInput.value){
this.lastInput.parentNode.className="";
}
this.lastInput.nextSibling.data =this.lastInput.value;
}
inp.style.display="";
if(!inp.nextSibling){
inp.parentNode.appendChild(document.createTextNode(" "));
}
this.lastData=inp.nextSibling.data;
inp.nextSibling.data =""
this.lastInput=inp;
}
}
}
function JSWikiTable (element){
var pre=element.getElementsByTagName("pre")[0];
var cnt=pre.innerHTML;
var table=document.createElement("table");
table.className="data";
var tbody=document.createElement("tbody");
var thead=document.createElement("thead");
var x=0;
var lines=cnt.split(/\|\|/);
for (var x=0;x < lines.length; x++){
var tr=document.createElement("tr");
var cols=lines[x].split(/\|/);
for (var y=0;y < cols.length;y++){
if(x == 0){
var th=document.createElement("th");
th.appendChild(document.createTextNode(cols[y]));
tr.appendChild(th);
}else{
var td=document.createElement("td");
td.appendChild(document.createTextNode(cols[y]));
tr.appendChild(td);
}
if(x == 0){
thead.appendChild(tr);
}else{
tbody.appendChild(tr);
}
}
}
table.appendChild(thead);
table.appendChild(tbody);
pre.parentNode.insertBefore(table,pre);
pre.style.display="none";
}
function JSAjaxTable(element){
var id=element.getAttribute("targetid");
var url=element.getAttribute("datasrc");
var loader=new XMLHttpRequestLoader;
this.loadTabTable=loadTabTable;
loader.loadText(url,this.loadTabTable)
function loadTabTable (cnt){
var target=document.getElementById(id);
var table=document.createElement("table");
var tbody=document.createElement("tbody");
var thead=document.createElement("thead");
var x=0;
var lines=cnt.split(/\n/);
for (var x=0;x < lines.length; x++){
if(!lines[x].match(/[a-zA-Z0-9]/)){ continue;}
var tr=document.createElement("tr");
var cols=lines[x].split(/\t/);
for (var y=0;y < cols.length;y++){
if(x == 0){
var th=document.createElement("th");
th.appendChild(document.createTextNode(cols[y]));
tr.appendChild(th);
}else{
var td=document.createElement("td");
td.appendChild(document.createTextNode(cols[y]));
tr.appendChild(td);
}
if(x == 0){
thead.appendChild(tr);
}else{
tbody.appendChild(tr);
}
}
}
table.appendChild(thead);
table.appendChild(tbody);
target.appendChild(table);
if(target.className.match("JSTableSort")){
sorts=target.getAttribute("datasrc");
ths=thead.getElementsByTagName("th");
if(sorts){
dsorts=sorts.split("||");
for (var j=0;j<dsorts.length;j++){
if(dsorts[j].match("Sorts:")){
msorts=dsorts[j].split(" ");
for (var i=0; i < ths.length;i++){
ths.item(i).className=msorts[i+1];
}
}
}
}
JSTableSort(target);
}
if(target.className.match("JSTableFilter")){
sorts=target.getAttribute("datasrc");
ths=thead.getElementsByTagName("th");
if(sorts){
dsorts=sorts.split("||");
for (var j=0;j<dsorts.length;j++){
if(dsorts[j].match("Filters:")){
msorts=dsorts[j].split(" ");
for (var i=0; i < ths.length;i++){
ths.item(i).className=ths.item(i).className+" "+msorts[i+1];
}
}
}
}
JSTableFilter(target);
}
if(target.className.match("JSTableScrollable")){
sorts=target.getAttribute("datasrc");
ths=thead.getElementsByTagName("th");
tds=tbody.getElementsByTagName("tr").item(0).getElementsByTagName("td");
if(sorts){
dsorts=sorts.split("||");
for (var j=0;j<dsorts.length;j++){
if(dsorts[j].match("Widths:")){
var totalWidth=0;
msorts=dsorts[j].split(" ");
for (var i=0; i < ths.length;i++){
ths.item(i).style.width=msorts[i+1]+"px";
ths.item(i).setAttribute("width",msorts[i+1])
tds.item(i).style.width=msorts[i+1]+"px";
totalWidth=parseInt(totalWidth)+parseInt(msorts[i+1]);
}
table.setAttribute("width",totalWidth);
table.style.width=totalWidth+"px";
tbody.setAttribute("width",totalWidth);
tbody.style.width=totalWidth+"px";
thead.setAttribute("width",totalWidth);
thead.style.width=totalWidth+"px";
}
if(dsorts[j].match("Height:")){
msorts=dsorts[j].split(" ");
target.style.height=msorts[1]+"px";
}
}
}
if(totalWidth>100){
target.style.width=parseInt(totalWidth)+20+"px";
}
var classNames=target.className;
while (classNames.match(/(JSExtra[^ ]+)(.*)/)){
try {
eval("mfunc="+RegExp.$1+";");
mfunc(target);
} catch (ev){}
classNames=RegExp.$2;
}
}
return;
}
}
/* JSTTip-Class */
function JSTTip (varname,filename,t){
var tipId ;
var lastTipId="null" ;
var responseXML=false ;
var vname=varname ;
var file=filename ;
var timeout=t ;
var lastNode=null ;
var timeMulti=2 ;
function getTooltip(){
/* tooltip construction */
var id="ttip" ;
if(arguments[0]){ id=arguments[0]; }
var tooltip ;
if(!document.getElementById(id)){
tooltip=document.createElement("DIV");
tooltip.visibility="hidden" ;
tooltip.setAttribute("id", id);
document.body.appendChild(tooltip);
}else{
tooltip=document.getElementById(id);
}
return tooltip ;
}
function getTTip (evt){
/* event resolution and tip positioning */
var e=evt || window.event ;

var node=evtGetTarget(e);
var div=getTooltip() ;
if(node.className == "JSTTip" || node.className == "JSInlineTooltip"){
/* alert(node);*/
if(e.stopPropagation) e.stopPropagation();
e.cancelBubble=true;


}

tipId=node.getAttribute("id");
window.setTimeout(''+vname+'.hideTTip()',timeout);
if(tipId){
tipId=tipId.slice(0, 6);
}
if(window.pageXOffset || window.pageYOffset){
x=window.pageXOffset+e.clientX ;
y=window.pageYOffset+e.clientY ;
} else if (document.documentElement.scrollTop || document.documentElement.scrollLeft){
x=document.documentElement.scrollLeft+e.clientX ;
y=document.documentElement.scrollTop+e.clientY ;
}else{
x=document.body.scrollLeft+e.clientX ;
y=document.body.scrollTop+e.clientY ;
}
if(x > 500){
x -= 250 ;
}
if(y > 300){
y -= 30;
}
div.style.left=x+"px";
div.style.top=y+"px";
if(file == null){
var spans=node.getElementsByTagName("span");
if(spans[0]){
div.innerHTML=spans[0].innerHTML;
div.style.visibility="visible" ;
}
} else if (node.className == "JSTTip" && !responseXML){
div.style.visibility="visible" ;
div.innerHTML="Loading data ..." ;
var loader=new XMLHttpRequestLoader;
loader.loadXML(file,displayTTip);
} else if (node.className == "JSTTip"){
div.style.visibility="visible" ;
div.innerHTML="Loading data ..." ;
timeMulti=1 ;
displayTTip(responseXML);
}
}
function displayTTip (response){
if(!tipId){
return;
}
responseXML=response ;
var divs=responseXML.getElementsByTagName("div");
for (var x=0;x < divs.length;x++){
if(divs.item(x).getAttribute('id').search(tipId) >= 0){
var div=getTooltip() ;
if(divs.item(x).innerHTML){
div.innerHTML=divs.item(x).innerHTML;
} else if (divs.item(x).xml){
div.innerHTML=divs.item(x).xml ;
}

break ;
}
}


}
function hideTTip(){
if(lastTipId == tipId){
var div=getTooltip() ;
div.style.visibility="hidden" ;
}else{
window.setTimeout(''+vname+'.hideTTip()',timeout*timeMulti);
}
lastTipId=tipId ;
}
function addEventsTTips (){
var spans=document.getElementsByTagName("span");
for (var i=0;i< spans.length;i++){
if(spans.item(i).className){
if(spans.item(i).className == "JSTTip"){
evtAdd(spans.item(i),"mouseover",getTTip);
} else if (spans.item(i).className == "tip"){
evtAdd(spans.item(i).parentNode,"mouseover",getTTip);
}
}
}

}
this.hideTTip=hideTTip;
addEventsTTips();
}
var jstt ;
function JSToolTip (element){
var path ;
var outtime ;
if(element.getAttribute("data") == null){
alert("JSToolTip: error you need data attribute like so data='path/tips.xhtml,timout'!");
}else{
var text=element.getAttribute("data");
var items=text.split(",");
}
jstt=new JSTTip('jstt',items[0],items[1]); 
}
function JSInlineTooltip (div){
jstt=new JSTTip('jstt',null,5000);
}
function JSCollapse(element){
var c=new JSTree(element);
}
function JSTree (element){
var lists=element.getElementsByTagName("LI") ;
this.toggleDisplay=toggleDisplay ;
this.expandcollapse=expandcollapse ;
this.hideAllSubLists=hideAllSubLists ;
this.listInit=listInit;
this.insertInclude=insertInclude;
evtAdd(element, "click", this.expandcollapse); 
listInit(lists);
hideAllSubLists(element, "");
function listInit(lists){
for (var i=0;i < lists.length; i++){
var listslists=lists.item(i).getElementsByTagName("LI") ;
if(listslists.length > 0){ 
if(lists.item(i).className != "opened"){
toggleDisplay(lists.item(i));
}
} else if (lists.item(i).className != "include"){
lists.item(i).className="leaf" ;
}
}
}

function hideAllSubLists(element, display){
var ul=element.childNodes ;
for (var i=0;i < ul.length;i++){
var node=ul.item(i) ;
if(node.nodeName == "LI" && node.getElementsByTagName("UL").item(0) &&
node.getElementsByTagName("UL").item(0).nodeName == "UL"){
node=node.getElementsByTagName("UL").item(0) ;
}
if(node.nodeName == "UL"){
node.style.display=display ;
}
}
}
function getNodeUp (node, nodeType){
while (node.nodeName != nodeType){
node=node.parentNode;
}
return node ;
}
function expandcollapse (e){
e=e||window.event;
var element=evtGetTarget(e);
var child ;
/* e.cancelBubble=true;*/

/* if (e.stopPropagation) e.stopPropagation();*/
try { if(window.event.srcElement.tagName != "LI" && window.event.srcElement.tagName != "SPAN") return; } catch (ev){}
toggleDisplay(element) ;
}
function insertInclude (response,el){
div=el.getElementsByTagName("div")[0];
el.removeChild(div);
el.innerHTML=el.innerHTML+response;
var lis=el.getElementsByTagName("LI");
if(lis.length > 0){ 
el.className="opened" ;
listInit(lis);
hideAllSubLists(el, "");

}else{
el.className="leaf";
}
el.style.cursor='pointer';
}
function toggleDisplay(el){
if(el.className == "include"){
el.style.cursor='wait';
var loader=new XMLHttpRequestLoader;
var dsrcdiv=el.getElementsByTagName("div")[0] ;
loader.loadText(dsrcdiv.getAttribute("datasrc"),insertInclude,el);
return ;

}

child=el.getElementsByTagName("UL")[0];
if(!child){
child=el.nextSibling ;
while (child != null){
if(child.nodeName == "UL"){ break };//"[object HTMLUListElement]"){ break }
child=child.nextSibling ;
}
}
if(child){
bCollapsed=(child.style.display == "none");
if(bCollapsed){
if(element.className == "JSTree" || element.className == "JSCollapse"){
el.className="opened" ;
}
child.style.display="";
}else{
if(element.className == "JSTree" || element.className == "JSCollapse"){
el.className="" ;
}
child.style.display="none" ;
}
}else{
el.className="leaf" ;
}
}

}
